
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Acceptance_criteriaDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const acceptance_criteria = await db.acceptance_criteria.create(
            {
                id: data.id || undefined,
        
        sort_order: data.sort_order
        ||
        null
            ,
            
        given_text: data.given_text
        ||
        null
            ,
            
        when_text: data.when_text
        ||
        null
            ,
            
        then_text: data.then_text
        ||
        null
            ,
            
        is_automatable: data.is_automatable
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await acceptance_criteria.setStory( data.story || null, {
            transaction,
        });
        
        await acceptance_criteria.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return acceptance_criteria;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const acceptance_criteriaData = data.map((item, index) => ({
                id: item.id || undefined,
                
                sort_order: item.sort_order
            ||
            null
            ,
            
                given_text: item.given_text
            ||
            null
            ,
            
                when_text: item.when_text
            ||
            null
            ,
            
                then_text: item.then_text
            ||
            null
            ,
            
                is_automatable: item.is_automatable
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const acceptance_criteria = await db.acceptance_criteria.bulkCreate(acceptance_criteriaData, { transaction });

        // For each item created, replace relation files
        

        return acceptance_criteria;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const acceptance_criteria = await db.acceptance_criteria.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.given_text !== undefined) updatePayload.given_text = data.given_text;
        
        
        if (data.when_text !== undefined) updatePayload.when_text = data.when_text;
        
        
        if (data.then_text !== undefined) updatePayload.then_text = data.then_text;
        
        
        if (data.is_automatable !== undefined) updatePayload.is_automatable = data.is_automatable;
        
        
        updatePayload.updatedById = currentUser.id;

        await acceptance_criteria.update(updatePayload, {transaction});

        
        
        if (data.story !== undefined) {
            await acceptance_criteria.setStory(
              
              data.story,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await acceptance_criteria.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return acceptance_criteria;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const acceptance_criteria = await db.acceptance_criteria.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of acceptance_criteria) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of acceptance_criteria) {
                await record.destroy({transaction});
            }
        });


        return acceptance_criteria;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const acceptance_criteria = await db.acceptance_criteria.findByPk(id, options);

        await acceptance_criteria.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await acceptance_criteria.destroy({
            transaction
        });

        return acceptance_criteria;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const acceptance_criteria = await db.acceptance_criteria.findOne(
            { where },
            { transaction },
        );

        if (!acceptance_criteria) {
            return acceptance_criteria;
        }

        const output = acceptance_criteria.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.story = await acceptance_criteria.getStory({
            transaction
        });
        
        
        output.organizations = await acceptance_criteria.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.user_stories,
        as: 'story',
        
        where: filter.story ? {
          [Op.or]: [
            { id: { [Op.in]: filter.story.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.story.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.given_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'acceptance_criteria',
                        'given_text',
                        filter.given_text,
                    ),
                };
            }
            
            if (filter.when_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'acceptance_criteria',
                        'when_text',
                        filter.when_text,
                    ),
                };
            }
            
            if (filter.then_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'acceptance_criteria',
                        'then_text',
                        filter.then_text,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_automatable) {
                where = {
                    ...where,
                is_automatable: filter.is_automatable,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.acceptance_criteria.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'acceptance_criteria',
                        'given_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.acceptance_criteria.findAll({
            attributes: [ 'id', 'given_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['given_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.given_text,
        }));
    }

    
};

